/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the MetricContext type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MetricContext{}

// MetricContext struct for MetricContext
type MetricContext struct {
	FieldName string `json:"field_name"`
	ObjectType *string `json:"object_type,omitempty"`
	Value ExpressionValue `json:"value"`
}

// NewMetricContext instantiates a new MetricContext object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMetricContext(fieldName string, value ExpressionValue) *MetricContext {
	this := MetricContext{}
	this.FieldName = fieldName
	this.Value = value
	return &this
}

// NewMetricContextWithDefaults instantiates a new MetricContext object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMetricContextWithDefaults() *MetricContext {
	this := MetricContext{}
	return &this
}

// GetFieldName returns the FieldName field value
func (o *MetricContext) GetFieldName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.FieldName
}

// GetFieldNameOk returns a tuple with the FieldName field value
// and a boolean to check if the value has been set.
func (o *MetricContext) GetFieldNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.FieldName, true
}

// SetFieldName sets field value
func (o *MetricContext) SetFieldName(v string) {
	o.FieldName = v
}

// GetObjectType returns the ObjectType field value if set, zero value otherwise.
func (o *MetricContext) GetObjectType() string {
	if o == nil || IsNil(o.ObjectType) {
		var ret string
		return ret
	}
	return *o.ObjectType
}

// GetObjectTypeOk returns a tuple with the ObjectType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MetricContext) GetObjectTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ObjectType) {
		return nil, false
	}
	return o.ObjectType, true
}

// HasObjectType returns a boolean if a field has been set.
func (o *MetricContext) HasObjectType() bool {
	if o != nil && !IsNil(o.ObjectType) {
		return true
	}

	return false
}

// SetObjectType gets a reference to the given string and assigns it to the ObjectType field.
func (o *MetricContext) SetObjectType(v string) {
	o.ObjectType = &v
}

// GetValue returns the Value field value
func (o *MetricContext) GetValue() ExpressionValue {
	if o == nil {
		var ret ExpressionValue
		return ret
	}

	return o.Value
}

// GetValueOk returns a tuple with the Value field value
// and a boolean to check if the value has been set.
func (o *MetricContext) GetValueOk() (*ExpressionValue, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Value, true
}

// SetValue sets field value
func (o *MetricContext) SetValue(v ExpressionValue) {
	o.Value = v
}

func (o MetricContext) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MetricContext) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["field_name"] = o.FieldName
	if !IsNil(o.ObjectType) {
		toSerialize["object_type"] = o.ObjectType
	}
	toSerialize["value"] = o.Value
	return toSerialize, nil
}

type NullableMetricContext struct {
	value *MetricContext
	isSet bool
}

func (v NullableMetricContext) Get() *MetricContext {
	return v.value
}

func (v *NullableMetricContext) Set(val *MetricContext) {
	v.value = val
	v.isSet = true
}

func (v NullableMetricContext) IsSet() bool {
	return v.isSet
}

func (v *NullableMetricContext) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMetricContext(val *MetricContext) *NullableMetricContext {
	return &NullableMetricContext{value: val, isSet: true}
}

func (v NullableMetricContext) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMetricContext) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


